Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1869)
@@ -2214,45 +2318,47 @@
   \param[in] apply inherit all attributes of parents (true)
   */
-  void CGrid::solveDomainAxisRefInheritance(bool apply)
-  TRY
-  {
-    CContext* context = CContext::getCurrent();
-    unsigned int vecSize, i;
-    std::vector<StdString>::iterator it, itE;
+  void CGrid::solveElementsRefInheritance(bool apply)
+  TRY
+  {
     setDomainList();
-    it = domList_.begin(); itE = domList_.end();
-    for (; it != itE; ++it)
-    {
-      CDomain* pDom = CDomain::get(*it);
-      if (context->getServiceType()==CServicesManager::CLIENT)
-      {
-        pDom->solveRefInheritance(apply);
-        pDom->solveInheritanceTransformation();
-      }
+    for (auto domainId : domList_)
+    {
+      CDomain* pDom = CDomain::get(domainId);
+      pDom->solveRefInheritance(apply);
+      pDom->solveInheritanceTransformation();
     }
 
     setAxisList();
-    it = axisList_.begin(); itE = axisList_.end();
-    for (; it != itE; ++it)
-    {
-      CAxis* pAxis = CAxis::get(*it);
-      if (context->getServiceType()==CServicesManager::CLIENT)
-      {
-        pAxis->solveRefInheritance(apply);
-        pAxis->solveInheritanceTransformation();
-      }
+    for (auto axisId : axisList_)
+    {
+      CAxis* pAxis = CAxis::get(axisId);
+      pAxis->solveRefInheritance(apply);
+      pAxis->solveInheritanceTransformation();
     }
 
     setScalarList();
-    it = scalarList_.begin(); itE = scalarList_.end();
-    for (; it != itE; ++it)
-    {
-      CScalar* pScalar = CScalar::get(*it);
-      if (context->getServiceType()==CServicesManager::CLIENT)
-      {
-        pScalar->solveRefInheritance(apply);
-        pScalar->solveInheritanceTransformation();
-      }
-    }
+    for (auto scalarId : scalarList_)
+    {
+      CScalar* pScalar = CScalar::get(scalarId);
+      pScalar->solveRefInheritance(apply);
+      pScalar->solveInheritanceTransformation();
+    }
+  }
+  CATCH_DUMP_ATTR
+
+ /*!
+  \brief check attributes of all elements of the grid
+  */
+  void CGrid::checkElementsAttributes(void)
+  TRY
+  {
+    setDomainList();
+    for (auto domainId : domList_) CDomain::get(domainId)->checkAttributes();
+
+    setAxisList();
+    for (auto axisId : axisList_) CAxis::get(axisId)->checkAttributes();
+    
+    setScalarList();
+    for (auto scalarId : scalarList_) CScalar::get(scalarId)->checkAttributes();
   }
   CATCH_DUMP_ATTR
@@ -2301,5 +2407,5 @@
   TRY
   {
-    if (0 != transformGridSrc)
+    if (nullptr != transformGridSrc)
     {
       if (axis_domain_order.numElements() != transformGridSrc->axis_domain_order.numElements())
@@ -2362,4 +2468,61 @@
   }
   CATCH_DUMP_ATTR
+
+
+
+
+  void CGrid::prepareTransformGrid(CGrid* transformGridSrc)
+  TRY
+  {
+    if (prepareTransformGrid_done_) return ;
+
+    if (!transformGridSrc)
+      ERROR("CGrid::transformGrid(CGrid* transformGridSrc)",
+            << "Impossible to transform grid '" << getId() << "', the source grid is null.");
+
+    if (isTransformed()) return;
+    setTransformed();
+    if (axis_domain_order.numElements() != transformGridSrc->axis_domain_order.numElements())
+    {
+      ERROR("CGrid::transformGrid(CGrid* transformGridSrc)",
+           << "Two grids have different number of elements. " << std::endl
+           << "Number of element of grid destination " << this->getId() << " is " << axis_domain_order.numElements() << std::endl
+           << "Number of element of grid source " << transformGridSrc->getId() << " is " << transformGridSrc->axis_domain_order.numElements());
+    }
+    else
+    {
+    }
+
+    transformations_ = new CGridTransformation(this, transformGridSrc);
+    if (0 < transformations_->getNbAlgo()) hasTransform_ = true;
+
+    prepareTransformGrid_done_ = true; 
+  }
+  CATCH_DUMP_ATTR
+
+
+  void CGrid::makeTransformGrid(void)
+  TRY
+  {
+    if (makeTransformGrid_done_) return ;
+    transformations_->computeAll();
+
+    makeTransformGrid_done_ = true ; 
+  }
+  CATCH_DUMP_ATTR
+
+
+  vector<std::string> CGrid::getAuxInputTransformGrid(void)
+  TRY
+  {
+    if (transformations_ != nullptr) return transformations_->getAuxInputs() ;
+  }
+  CATCH_DUMP_ATTR
+
+
+
+
+
+
 
   bool CGrid::hasTransform()
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1869)
@@ -71,5 +71,5 @@
          void checkEligibilityForCompressedOutput();
 
-         void solveDomainAxisRef(bool areAttributesChecked);
+
 
          void checkMaskIndex(bool doCalculateIndex);
@@ -89,15 +89,15 @@
          StdSize getDimension(void);
 
-         StdSize  getDataSize(void) const;
+         StdSize  getDataSize(void) ;
 
          /// Entrees-sorties de champs
          template <int n>
-         void inputField(const CArray<double,n>& field, CArray<double,1>& stored) const;
+         void inputField(const CArray<double,n>& field, CArray<double,1>& stored) ;
          template <int n>
-         void maskField(const CArray<double,n>& field, CArray<double,1>& stored) const;
+         void maskField(const CArray<double,n>& field, CArray<double,1>& stored) ;
          template <int n>
-         void outputField(const CArray<double,1>& stored, CArray<double,n>& field) const;  
+         void outputField(const CArray<double,1>& stored, CArray<double,n>& field) ;  
          template <int n>
-         void uncompressField(const CArray<double,n>& data, CArray<double,1>& outData) const; 
+         void uncompressField(const CArray<double,n>& data, CArray<double,1>& outData) ; 
 
          virtual void parse(xml::CXMLNode& node);
@@ -133,10 +133,12 @@
          void computeIndexScalarGrid();
          void computeWrittenIndex();
+         void solveDomainAxisRef(bool areAttributesChecked);
+         void checkElementsAttributes(void) ;
 
          void solveDomainRef(bool checkAtt);
          void solveAxisRef(bool checkAtt);
          void solveScalarRef(bool checkAtt);
-         void solveDomainAxisRefInheritance(bool apply = true);
-         void solveTransformations();
+         void solveElementsRefInheritance(bool apply = true);
+        // void solveTransformations();
          void solveDomainAxisBaseRef();
 
@@ -195,4 +197,13 @@
 
          void transformGrid(CGrid* transformGridSrc);
+         
+         void prepareTransformGrid(CGrid* transformGridSrc);
+         bool prepareTransformGrid_done_ = false ;
+
+         void makeTransformGrid(void); 
+         bool makeTransformGrid_done_ = false ;
+         
+         std::vector<std::string> getAuxInputTransformGrid(void) ; 
+
          void completeGrid(CGrid* transformGridSrc = 0);
          void doAutoDistribution(CGrid* transformGridSrc);
@@ -205,4 +216,6 @@
          bool hasTransform();
          size_t getGlobalWrittenSize(void) ;
+         bool checkIfCompleted(void) ;
+
 
          bool hasMask(void) const;
@@ -217,5 +230,10 @@
                                          const CArray<int,1>& axisDomainOrder);
 
+         void computeGridIndexToFileServer(CContextClient* client) ;
+
       private:
+       void computeClientDistribution(void) ;
+       bool computeClientDistribution_done_ = false ;
+
        template<int N>
        void checkGridMask(CArray<bool,N>& gridMask,
@@ -230,8 +248,8 @@
         void modifyGridMaskSize(CArray<bool,N>& gridMask, const std::vector<int>& eachDimSize, bool newValue);
 
-        void storeField_arr(const double* const data, CArray<double, 1>& stored) const;
-        void restoreField_arr(const CArray<double, 1>& stored, double* const data) const;
-        void uncompressField_arr(const double* const data, CArray<double, 1>& outData) const;
-        void maskField_arr(const double* const data, CArray<double, 1>& stored) const;
+        void storeField_arr(const double* const data, CArray<double, 1>& stored) ;
+        void restoreField_arr(const CArray<double, 1>& stored, double* const data) ;
+        void uncompressField_arr(const double* const data, CArray<double, 1>& outData) ;
+        void maskField_arr(const double* const data, CArray<double, 1>& stored) ;
 
         void setVirtualDomainGroup(CDomainGroup* newVDomainGroup);
@@ -259,9 +277,16 @@
         int getDistributedDimension();
 
+       
         void computeClientIndex();
-        void computeConnectedClients();
+        bool computeClientIndex_done_ = false ;
+        
+        void computeConnectedClients(CContextClient* client);
+        set<CContextClient*> computeConnectedClients_done_ ;
+
         void computeClientIndexScalarGrid(); 
-        void computeConnectedClientsScalarGrid(); 
-
+        bool computeClientIndexScalarGrid_done_ = false ;
+
+        void computeConnectedClientsScalarGrid(CContextClient* client); 
+        set<CContextClient*> computeConnectedClientsScalarGrid_done_ ;
 
       public:
@@ -270,10 +295,16 @@
  *  Used to store field from model into the worklow, or to return field into models.  
  *  The size of the array is the number of local index of the workflow grid */        
-         CArray<int, 1> storeIndex_client_;
+        CArray<int, 1> storeIndex_client_;
+        void computeStoreIndex_client(void) ;
+        bool computeStoreIndex_client_done_ = false ;
+        CArray<int, 1>& getStoreIndex_client(void) { if (!computeStoreIndex_client_done_) computeStoreIndex_client() ; return storeIndex_client_ ;}
 
 /** Array containing the grid mask masked defined by the mask_nd grid attribute.        
   * The corresponding masked field value provided by the model will be replaced by a NaN value
   * in the workflow.  */
-         CArray<bool, 1> storeMask_client_;
+        CArray<bool, 1> storeMask_client_;
+        void computeStoreMask_client(void) ;
+        bool computeStoreMask_client_done_ = false ;
+        CArray<bool, 1>& getStoreMask_client(void) { if (!computeStoreMask_client_done_) computeStoreMask_client() ; return storeMask_client_ ;}
 
 /** Map containing the indexes on client side that will be sent to each connected server.
@@ -419,5 +450,5 @@
 
    template <int n>
-   void CGrid::inputField(const CArray<double,n>& field, CArray<double,1>& stored) const
+   void CGrid::inputField(const CArray<double,n>& field, CArray<double,1>& stored)
    TRY
    {
@@ -435,5 +466,5 @@
 
    template <int n>
-   void CGrid::maskField(const CArray<double,n>& field, CArray<double,1>& stored) const
+   void CGrid::maskField(const CArray<double,n>& field, CArray<double,1>& stored)
    {
 //#ifdef __XIOS_DEBUG
@@ -449,5 +480,5 @@
 
    template <int n>
-   void CGrid::outputField(const CArray<double,1>& stored, CArray<double,n>& field) const
+   void CGrid::outputField(const CArray<double,1>& stored, CArray<double,n>& field)
    TRY
    {
@@ -471,5 +502,5 @@
    */
    template <int N>
-   void CGrid::uncompressField(const CArray<double,N>& data, CArray<double,1>& outData) const
+   void CGrid::uncompressField(const CArray<double,N>& data, CArray<double,1>& outData)
    TRY
    {      
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 1869)
@@ -59,4 +59,7 @@
    void CScalar::checkAttributes(void)
    {
+      if (checkAttributes_done_) return ;
+
+      checkAttributes_done_ = true ; 
    }
 
@@ -65,4 +68,42 @@
 
   }
+
+  /*!
+  \brief Check if a scalar is completed
+  Before make any scalar processing, we must be sure that all scalar informations have
+  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+  other context (coupling). So all direct reference of the scalar (scalar_ref) must be also completed
+  \return true if scalar and scalar reference are completed
+  */
+  bool CScalar::checkIfCompleted(void)
+  {
+    if (hasDirectScalarReference()) if (!getDirectScalarReference()->checkIfCompleted()) return false;
+    return isCompleted_ ;
+  }
+
+  /*!
+  \brief Set a scalar as completed
+   When all information about a scalar have been received, the scalar is tagged as completed and is
+   suitable for processing
+  */
+  void CScalar::setCompleted(void)
+  {
+    if (hasDirectScalarReference()) getDirectScalarReference()->setCompleted() ;
+    isCompleted_=true ;
+  }
+
+  /*!
+  \brief Set a scalar as uncompleted
+   When informations about a scalar are expected from a grid reading from file or coupling, the scalar is 
+   tagged as uncompleted and is not suitable for processing
+  */
+  void CScalar::setUncompleted(void)
+  {
+    if (hasDirectScalarReference()) getDirectScalarReference()->setUncompleted() ;
+    isCompleted_=false ;
+  }
+
+
+
 
   /*!
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 1869)
@@ -66,8 +66,14 @@
          public:
             void checkAttributes(void);
+            bool checkAttributes_done_ = false ;
+            
             void addRelFile(const StdString& filename);
             bool IsWritten(const StdString& filename) const;
             void checkAttributesOnClient();
             virtual void parse(xml::CXMLNode & node);
+
+            bool checkIfCompleted(void) ;
+            void setCompleted(void) ;
+            void setUncompleted(void) ;
 
          public:
@@ -90,4 +96,7 @@
            static bool dummyTransformationMapList_;
 
+           /** define if the scalar is completed or not ie all attributes have been received before in case 
+               of grid reading from file or coupling */ 
+           bool isCompleted_=true ;  
 
             DECLARE_REF_FUNC(Scalar,scalar)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory.hpp	(revision 1869)
@@ -50,5 +50,8 @@
          template <typename U>
             static  std::shared_ptr<U> CreateObject(const StdString & id = StdString(""));
-
+ 
+         template <typename U>
+             static std::shared_ptr<U> CreateAlias(const StdString& id, const StdString& alias) ;
+         
          template <typename U> static const StdString& GetUIdBase(void);
          template <typename U> static StdString GenUId(void);
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_decl_macro.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_decl_macro.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_decl_macro.hpp	(revision 1869)
@@ -13,4 +13,5 @@
   template bool CObjectFactory::HasObject<U>(const StdString& context,const StdString& id); \
   template std::shared_ptr<U> CObjectFactory::CreateObject<U>(const StdString& id ); \
+  template std::shared_ptr<U> CObjectFactory::CreateAlias<U>(const StdString& id, const StdString& alias ); \
   template const StdString& CObjectFactory::GetUIdBase<U>(void); \
   template StdString CObjectFactory::GenUId<U>(void); \
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_impl.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_impl.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/object_factory_impl.hpp	(revision 1869)
@@ -113,4 +113,31 @@
 
    template <typename U>
+   std::shared_ptr<U> CObjectFactory::CreateAlias(const StdString& id, const StdString& alias)
+   {
+      if (CurrContext.empty())
+         ERROR("CObjectFactory::CreateAlias(const StdString& id, const StdString& alias)",
+               << "[ id = " << id << " alias = "<<alias<<" ] please define current context id !");
+
+      if (CObjectFactory::HasObject<U>(alias))
+      {
+         return CObjectFactory::GetObject<U>(alias);
+      }
+      else
+      {
+        if (! CObjectFactory::HasObject<U>(id))
+        {
+            ERROR("CObjectFactory::CreateAlias(const StdString& id, const StdString& alias)",
+               << "[ id = " << id << " alias = "<<alias<<" ] object id doesn't exist"); 
+        }
+        else  
+        {
+          std::shared_ptr<U> value = CObjectFactory::GetObject<U>(id);  
+          U::AllMapObj[CObjectFactory::CurrContext].insert(std::make_pair(alias, value));
+          return value;
+         }
+      }
+   }
+
+   template <typename U>
       const std::vector<std::shared_ptr<U> > &
          CObjectFactory::GetObjectVector(const StdString & context)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp	(revision 1869)
@@ -83,4 +83,7 @@
 
          static T* create(const string& id=string("")) ;
+         static T* createAlias(const string& id, const string& alias) ;
+         void createAlias(const string& alias) ;
+         
          static const vector<T*> getAll() ;
          static const vector<T*> getAll(const string& contextId) ;
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp	(revision 1869)
@@ -420,4 +420,16 @@
    }   ///--------------------------------------------------------------
 
+   template <typename T>
+   T* CObjectTemplate<T>::createAlias(const string & id, const string& alias)
+   {
+     return CObjectFactory::CreateAlias<T>(id, alias).get();
+   }   ///--------------------------------------------------------------
+
+   template <typename T>
+   void CObjectTemplate<T>::createAlias(const string& alias)
+   {
+     get()->createAlias(getId(),alias) ;
+   }   //
+
   template <typename T>
   T* CObjectTemplate<T>::get(void)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/parse_expr/filter_expr_node.cpp	(revision 1869)
@@ -40,6 +40,6 @@
                 << "Use the keyword \"this\" if you want to reference the input data sent to this field.");
 
-        field->buildFilterGraph(gc, false);
-        outputPin = field->getInstantDataFilter();
+        bool ret=field->buildWorkflowGraph(gc);
+        if (ret) outputPin = field->getInstantDataFilter(); // if dependency is complete build the graph other return nullptr
       }
       else ERROR("boost::shared_ptr<COutputPin> CFilterFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const",
@@ -84,6 +84,6 @@
                 << "Use the keyword \"this\" if you want to reference the input data sent to this field.");
 
-        field->buildFilterGraph(gc, false);
-        outputPin = field->getTemporalDataFilter(gc, thisField.freq_op.isEmpty() ? TimeStep : thisField.freq_op);
+        bool ret=field->buildWorkflowGraph(gc);
+        if (ret) outputPin = field->getTemporalDataFilter(gc, thisField.freq_op.isEmpty() ? TimeStep : thisField.freq_op);
       }
       else
@@ -107,5 +107,7 @@
   {
     std::shared_ptr<CUnaryArithmeticFilter> filter(new CUnaryArithmeticFilter(gc, opId));
-    child->reduce(gc, thisField)->connectOutput(filter, 0);
+    auto ret=child->reduce(gc, thisField) ;
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -124,5 +126,8 @@
   {
     std::shared_ptr<CScalarFieldArithmeticFilter> filter(new CScalarFieldArithmeticFilter(gc, opId, child1->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
+    
+    auto ret=child2->reduce(gc, thisField) ;
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -141,5 +146,7 @@
   {
     std::shared_ptr<CFieldScalarArithmeticFilter> filter(new CFieldScalarArithmeticFilter(gc, opId, child2->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    auto ret=child1->reduce(gc, thisField) ;
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -158,6 +165,12 @@
   {
     std::shared_ptr<CFieldFieldArithmeticFilter> filter(new CFieldFieldArithmeticFilter(gc, opId));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1);
+    auto ret1 = child1->reduce(gc, thisField);
+    auto ret2 = child2->reduce(gc, thisField);
+    if (ret1 && ret2) 
+    {
+      ret1->connectOutput(filter, 0) ;
+      ret2->connectOutput(filter, 1) ;
+    }
+    else filter.reset() ;
     return filter;
   }
@@ -180,5 +193,7 @@
   {
     std::shared_ptr<CScalarScalarFieldArithmeticFilter> filter(new CScalarScalarFieldArithmeticFilter(gc, opId, child1->reduce(),child2->reduce()));
-    child3->reduce(gc, thisField)->connectOutput(filter, 0);
+    auto ret=child3->reduce(gc, thisField) ;
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -199,5 +214,7 @@
   {
     std::shared_ptr<CScalarFieldScalarArithmeticFilter> filter(new CScalarFieldScalarArithmeticFilter(gc, opId, child1->reduce(),child3->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
+    auto ret=child2->reduce(gc, thisField);
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -218,6 +235,12 @@
   {
     std::shared_ptr<CScalarFieldFieldArithmeticFilter> filter(new CScalarFieldFieldArithmeticFilter(gc, opId, child1->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
-    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    auto ret1=child2->reduce(gc, thisField);
+    auto ret2=child3->reduce(gc, thisField);
+    if (ret1 && ret2)
+    {
+      ret1->connectOutput(filter, 0);
+      ret2->connectOutput(filter, 1);
+    }
+    else filter.reset() ;
     return filter;
   }
@@ -239,5 +262,7 @@
   {
     std::shared_ptr<CFieldScalarScalarArithmeticFilter> filter(new CFieldScalarScalarArithmeticFilter(gc, opId, child2->reduce(),child3->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    auto ret = child1->reduce(gc, thisField) ;
+    if (ret) ret->connectOutput(filter, 0);
+    else filter.reset() ;
     return filter;
   }
@@ -259,6 +284,12 @@
   {
     std::shared_ptr<CFieldScalarFieldArithmeticFilter> filter(new CFieldScalarFieldArithmeticFilter(gc, opId, child2->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    auto ret1 = child1->reduce(gc, thisField);
+    auto ret2 = child3->reduce(gc, thisField);
+    if (ret1 && ret2)
+    {
+      ret1 -> connectOutput(filter, 0);
+      ret2 -> connectOutput(filter, 1);
+    }
+    else filter.reset() ;
     return filter;
   }
@@ -280,6 +311,12 @@
   {
     std::shared_ptr<CFieldFieldScalarArithmeticFilter> filter(new CFieldFieldScalarArithmeticFilter(gc, opId, child3->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1);
+    auto ret1 = child1->reduce(gc, thisField);
+    auto ret2 = child2->reduce(gc, thisField);
+    if (ret1 && ret2)
+    {
+      ret1->connectOutput(filter, 0);
+      ret2->connectOutput(filter, 1);
+    }
+    else filter.reset() ;
     return filter;
   }
@@ -300,7 +337,14 @@
   {
     std::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1);
-    child3->reduce(gc, thisField)->connectOutput(filter, 2);
+    auto ret1=child1->reduce(gc, thisField);
+    auto ret2=child2->reduce(gc, thisField);
+    auto ret3=child3->reduce(gc, thisField);
+    if (ret1 && ret2 && ret3)
+    {
+      ret1->connectOutput(filter, 0);
+      ret2->connectOutput(filter, 1);
+      ret3->connectOutput(filter, 2);
+    }
+    else filter.reset() ;
     return filter;
   }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90	(revision 1869)
@@ -258,5 +258,5 @@
     
     ok_field3D_recv_W=xios_is_valid_field("field3D_recv_W").AND.xios_is_valid_field("field3D_resend_W") ;
-    IF (ok_field3D_recv) THEN
+    IF (ok_field3D_recv_W) THEN
       CALL xios_is_defined_field_attr("field3D_recv_W",freq_op=ok)
       IF (ok) THEN
@@ -463,5 +463,5 @@
     
     ok_other_field3D_recv_W=xios_is_valid_field("other_field3D_recv_W").AND.xios_is_valid_field("other_field3D_resend_W") ;
-    IF (ok_other_field3D_recv) THEN
+    IF (ok_other_field3D_recv_W) THEN
       CALL xios_is_defined_field_attr("other_field3D_recv_W",freq_op=ok)
       IF (ok) THEN
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm_interpolate.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm_interpolate.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm_interpolate.cpp	(revision 1869)
@@ -313,5 +313,5 @@
   {
     CField* field = CField::get(coordinate_);
-    CGrid* grid = field->grid;
+    CGrid* grid = field->getGrid();
 
     std::vector<CDomain*> domListP = grid->getDomains();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_transformation.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_transformation.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_transformation.cpp	(revision 1869)
@@ -246,5 +246,6 @@
   }
 
-  tmpGridDestination_ = CGrid::createGrid(domainDst, axisDst, scalarDst, elementOrder);  
+  tmpGridDestination_ = CGrid::createGrid(domainDst, axisDst, scalarDst, elementOrder); 
+  tmpGridDestination_-> solveElementsRefInheritance() ; // ym not sure 
   tempGridDests_.push_back(tmpGridDestination_);
 }
@@ -292,5 +293,5 @@
         domain->domain_ref.setValue(domListDestP[elementIndex]->getId());
         domain->solveRefInheritance(true);
-        domain->checkAttributesOnClient();
+        domain->checkAttributes();
         domainSrc.push_back(domain);
       }
@@ -300,5 +301,5 @@
         axis->axis_ref.setValue(axisListDestP[elementIndex]->getId());
         axis->solveRefInheritance(true);
-        axis->checkAttributesOnClient();
+        axis->checkAttributes();
         axisSrc.push_back(axis); 
       }
@@ -308,5 +309,5 @@
         scalar->scalar_ref.setValue(scalarListDestP[elementIndex]->getId());
         scalar->solveRefInheritance(true);
-        scalar->checkAttributesOnClient();
+        scalar->checkAttributes();
         scalarSrc.push_back(scalar);
       }
@@ -334,4 +335,5 @@
 
   gridSource_ = CGrid::createGrid(domainSrc, axisSrc, scalarSrc, tmpGridDestination_->axis_domain_order);  
+  gridSource_->solveElementsRefInheritance() ; // ym not sure
 
   tempGridSrcs_.push_back(gridSource_);
